require 'cgi'

class Supportal::JIRA

  def initialize(user, pass, instance)
    @host = instance
    @user = user
    @pass = pass
    @search = '/rest/api/2/search'
  end

  def fetch_issues(query)
    path = @search + '?fields=key,summary&jql='
    jql = CGI.escape(query)
    issues = Supportal::Request.get_json(@host + path + jql, @user, @pass)
    issues['issues'].map do |issue|
      {
        key: issue['key'],
        summary: issue['fields']['summary'],
        instance: @host
      }
    end
  end

  def fetch_changelogs(query, changelog_field_id)
    path = @search + "?fields=key,customfield_#{changelog_field_id}&jql="
    jql = CGI.escape(query)
    issues = Supportal::Request.get_json(@host + path + jql, @user, @pass)
    issues['issues'].map do |issue|
      {
        key: issue['key'],
        changelog: issue['fields']["customfield_#{changelog_field_id}"]
      }
    end
  end

end
