require 'json'
require 'net/http'
require 'net/https'
require 'uri'

class Supportal::Request

  def self.get(url, user, pass, content_type='application/json')
    logger = Supportal::MicrosLogger.create(STDOUT)
    logger.level = Logger::DEBUG # FIXME
    uri = URI(url)
    logger.debug("Opening connection to: #{uri.host}")
    http = Net::HTTP.new(uri.host, 443)
    http.use_ssl = true
    logger.debug("Requesting: #{url}")
    request = Net::HTTP::Get.new(url)
    request.basic_auth(user, pass)
    request.content_type = content_type
    body = false
    begin
      http.request(request) do |response|
        body = response.body
      end
    rescue Exception => e
      logger.error("Error '#{e}' when downloading: #{url}")
    end
    return body
  end

  def self.get_json(url, user, pass)
    JSON.parse(self.get(url, user, pass))
  end

end
